> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://developers.awork.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://developers.awork.com/_mcp/server.

# Updates multiple time entries using the operation.

POST https://api.awork.com/api/v1/timeentries/batch/{operation}
Content-Type: application/json

Updates multiple time entries using the operation. Each requested change is reported separately.
The user must have permission to access the requested time entries.

Reference: https://developers.awork.com/apiv1/time-entries/post-time-entries-batch-by-operation

## Authentication

- `Authorization` header (bearer token, required) — Bearer authentication of the form `Bearer <token>`, where token is your auth token.

## Request

### Path parameters

- `operation` (string, required) — The batch operation type.

### Body (application/json)

This endpoint expects a TimeEntryBatchOperationForm.

- `timeEntryIds` (list of string, required) — The list of time entry ids to perform the batch operation on.
- `newTypeOfWorkId` (string, optional, nullable) — The id of the new type of work. Required for operation 'setTypeOfWork'.
- `isBillable` (boolean, optional, nullable) — Set the billable flag for time entries. Required for operation 'setIsBillable'.
- `isBilled` (boolean, optional, nullable) — Set the billed flag for time entries. Required for operation 'setIsBilled'.
- `requireAllTimeEntries` (boolean, optional) — Whether the operation must leave every requested time entry unchanged when any entry cannot be updated.
- `newUserId` (string, optional, nullable) — The id of the new user to assign the time entries to. Required for operation 'setUser'.
- `newProjectId` (string, optional, nullable) — The id of the new project to assign the time entries to. Required for operation 'setProject'.
- `newTaskId` (string, optional, nullable) — The id of the new task to assign the time entries to. Required for operation 'setTask'.

## Response

### 207

Multi-Status

- `ok` (StatusResult, optional) — The entity IDs with the same batch operation outcome.
- `notFound` (StatusResult, optional) — The entity IDs with the same batch operation outcome.
- `unauthorized` (StatusResult, optional) — The entity IDs with the same batch operation outcome.
- `badRequest` (StatusResult, optional) — The entity IDs with the same batch operation outcome.

## Errors

### 400 Bad Request Error

Bad Request

- `code` (string, required) — The error code.
- `description` (string, required) — The description of the error.
- `link` (string, required) — The link to the API documentation page.
- `details` (list of string, optional, nullable) — A list of details describing the error.
- `validationErrors` (list of ValidationErrorResponse, optional, nullable) — If a validation error occurred, this contains the validation errors for each property.
- `traceId` (string, optional, nullable) — The request trace id for tracking the request.

### 404 Not Found Error

Not Found

- `code` (string, required) — The error code.
- `description` (string, required) — The description of the error.
- `link` (string, required) — The link to the API documentation page.
- `details` (list of string, optional, nullable) — A list of details describing the error.
- `validationErrors` (list of ValidationErrorResponse, optional, nullable) — If a validation error occurred, this contains the validation errors for each property.
- `traceId` (string, optional, nullable) — The request trace id for tracking the request.

## Types

### StatusResult

The entity IDs with the same batch operation outcome.

- `ids` (list of string, optional, nullable) — The affected entity IDs.

### ValidationErrorResponse

The validation error response.

- `property` (string, optional, nullable) — The name of the property that failed validation.
- `message` (string, optional, nullable) — The reason why this property failed validation.

## Examples

**Request**

```json
{
  "timeEntryIds": [
    "string"
  ]
}
```

**Response**

```json
{
  "ok": {
    "ids": [
      "string"
    ]
  },
  "notFound": {
    "ids": [
      "string"
    ]
  },
  "unauthorized": {
    "ids": [
      "string"
    ]
  },
  "badRequest": {
    "ids": [
      "string"
    ]
  }
}
```

**SDK Code**

```python
import requests

url = "https://api.awork.com/api/v1/timeentries/batch/operation"

payload = { "timeEntryIds": ["string"] }
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.awork.com/api/v1/timeentries/batch/operation';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"timeEntryIds":["string"]}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.awork.com/api/v1/timeentries/batch/operation"

	payload := strings.NewReader("{\n  \"timeEntryIds\": [\n    \"string\"\n  ]\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.awork.com/api/v1/timeentries/batch/operation")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"timeEntryIds\": [\n    \"string\"\n  ]\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.awork.com/api/v1/timeentries/batch/operation")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"timeEntryIds\": [\n    \"string\"\n  ]\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.awork.com/api/v1/timeentries/batch/operation', [
  'body' => '{
  "timeEntryIds": [
    "string"
  ]
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.awork.com/api/v1/timeentries/batch/operation");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"timeEntryIds\": [\n    \"string\"\n  ]\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = ["timeEntryIds": ["string"]] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.awork.com/api/v1/timeentries/batch/operation")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```